<?php
/*
** Zabbix
** Copyright (C) 2001-2019 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


require_once dirname(__FILE__).'/include/config.inc.php';

$page['title'] = _('Password encryption');
$page['file'] = 'elisa.tools.password.php';

require_once dirname(__FILE__).'/include/page_header.php';

$themes = array_keys(Z::getThemes());

$fields = [
	'PASSWORD' 					=> [T_ZBX_STR, O_OPT, null, null, null],
	'KEY' 						=> [T_ZBX_STR, O_OPT, null, null, null],
	// actions
	'encrypt'					=> [T_ZBX_STR, O_OPT, P_SYS|P_ACT, null, null],
	
	'form_refresh'				=> [T_ZBX_INT, O_OPT, null, null, null]
];
check_fields($fields);

$data = [
	'password' => '',
	'key' => '',
	'encrypted' => '',
	'backurl' => $page['file']
];

/*
 * Actions
 */
if (hasRequest('encrypt')) {
	$data['password'] = getRequest('PASSWORD', '');
	$data['key'] = getRequest('KEY', '');
	if($data['password']!='' && $data['key']!=''){
		$cmdout = exec('/usr/bin/perl /usr/share/elisa/tools/encrypt_passwd.pl "'.getRequest('PASSWORD', '').'" "'.getRequest('KEY', '').'"', $output, $rc1);
		if($rc1!=0){
			show_messages(false, '', _('Error occured during password encryption'));
		}else{
			if(count($output)==3){
				$encrypted = explode('=',str_replace(' ', '', $output[2]));
				$data['encrypted'] = $encrypted[1];
			}else{
				show_messages(false, '', _('Error occured during password encryption'));
			}
		}
	}else{
		show_messages(false, '', _('Enter Password and Key'));
	}
}


$view = new CView('elisa.tools.password', $data);
$view->render();
$view->show();

require_once dirname(__FILE__).'/include/page_footer.php';
