<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


define('ELISA_CONF',	'/usr/share/elisa/conf/elisa.conf');

$BACKUP_PATH = shell_exec('grep -i BACKUP_PATH= '.ELISA_CONF.' | cut -d= -f2 | cut -d# -f1');

define('BACKUP_PATH',trim($BACKUP_PATH));

require_once dirname(__FILE__).'/include/config.inc.php';
require_once dirname(__FILE__).'/include/js.inc.php';

$page['title'] = _('ELISA Backup');
$page['file'] = 'elisa_backup_getfile.php';
$page['hist_arg'] = array('config');

require_once dirname(__FILE__).'/include/page_header.php';

//	VAR		TYPE	OPTIONAL FLAGS	VALIDATION	EXCEPTION
$fields = array(
	'date' =>				[T_ZBX_STR, O_OPT, null,	null,		null],
	'type' =>				[T_ZBX_STR, O_OPT, null,	IN('"configuration","logdata","zabbixdb","jasperserver"'),		null]
);
check_fields($fields);



/*
 * Permissions
 */
 

/*
 * Actions
 */



/*
 * Display
 */


$date = getRequest('date');
$type = getRequest('type');

$file = null;

	
$backups = array();
if(is_dir(BACKUP_PATH)){
	$backupDirs = scandir(BACKUP_PATH);
	foreach ($backupDirs as $backupDir) {
		if(is_dir(BACKUP_PATH.'/'.$backupDir) && strpos(strtolower($backupDir),strtolower($date))!== FALSE){
			$backupFiles = scandir(BACKUP_PATH.'/'.$backupDir);
			foreach ($backupFiles as $backupFile) {
				$filename = BACKUP_PATH.'/'.$backupDir.'/'.$backupFile;
				if(is_file($filename) && strpos(strtolower($filename),strtolower($date))!== FALSE && strpos(strtolower($filename),strtolower($type))!== FALSE){
					$file = $filename;
				}
			}				
		}
	}	
}	

if (isset($file) && file_exists($file)) {
	ob_clean();
	ob_end_flush();
	header('Content-Description: File Transfer');
	header('Content-Type: application/octet-stream');
	header('Content-Disposition: attachment; filename="'.basename($file).'"');
	header('Expires: 0');
	header('Cache-Control: must-revalidate');
	header('Pragma: public');
	header('Content-Length: ' . filesize($file));
	#readfile($file);
	$handle = fopen($file, "rb");
	while (!feof($handle)) {
		echo fread($handle, 1000);
	}	
	exit;
}else{
	header('HTTP/1.0 404 Not Found');
	echo "<h1>ELISA Backup</h1>";
	echo "<br/>";
	echo "The file that you have requested could not be found.";
	require_once dirname(__FILE__).'/include/page_footer.php';
	exit;
}





