<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/



define('TMP_DIRECTORY','/tmp');
define('ELISA_INSTALLLIC_SCRIPT','sudo /usr/share/elisa/bin/elisa-installLicense.sh');
define('ELISA_PRINTLIC_SCRIPT','sudo /usr/share/elisa/bin/elisa-printLicense.sh');
define('ELISA_LIC_FILE','/usr/share/elisa/conf/elisa.lic');
define('ELISA_LIC_FILE_GPG','/usr/share/elisa/conf/elisa.lic.gpg');

define('HOST_COUNT_ITEMKEY','zbx.probe.elasticsearch.cardinalitystats.max[AEFN.Host,4h,1w]');


require_once dirname(__FILE__).'/include/config.inc.php';
require_once dirname(__FILE__).'/include/js.inc.php';


$page['title'] = _('ELISA License');
$page['file'] = 'elisa_license.php';
$page['hist_arg'] = array();

require_once dirname(__FILE__).'/include/page_header.php';

$themes = array_keys(Z::getThemes());
$themes[] = THEME_DEFAULT;

// VAR	TYPE	OPTIONAL	FLAGS	VALIDATION	EXCEPTION
$fields = array(
	'backurl' => [T_ZBX_STR, O_OPT, null, null, null],
	'update' => [T_ZBX_STR, O_OPT, P_SYS|P_ACT, null, null],
	'cancel' => [T_ZBX_STR, O_OPT, P_SYS, null, null]
);
check_fields($fields);


	
/*
 * Actions
 */
$data = [];	

$result = true;

if(sizeof($_FILES)>0){
		
	if(isset($_FILES['licfile'])){
		$message_ok = '';
		$message_err = '';
		if($_FILES['licfile']['error']==0){
			$licfile = TMP_DIRECTORY."/".$_FILES['licfile']['name'];
			if (move_uploaded_file($_FILES['licfile']['tmp_name'],$licfile)) {
				if(file_exists($licfile)){
					exec(ELISA_INSTALLLIC_SCRIPT.' "'.$licfile.'"', $licStatus, $rc);
					$result = true;	
					if($rc==0){
						$message_ok = _('License succesfully installed');
						add_audit_details(AUDIT_ACTION_UPDATE, 99, 0, $_FILES['licfile']['name'], 'license');
					}else{
						if($rc==2){
							$message_err = _('License file is not valid');
						}if($rc==3){
							$message_err = _('License signature is not valid');
						}if($rc==5){
							$message_err = _('License is not issued for this IP');
						}else{
							$message_err = _('Error occured during installing license');
						}
						$result = false;	
					}
				}else{
					$message_err = _('Error occured during installing license');
					$result = false;												
				}
			} else {
				//$message_err = _('Při nahrávání souborů došlo k chybě');
				$message_err = _('Error occured during file upload');
				$result = false;
			};						
		}else{
			$result = false;
			//$message_err = _('Při nahrávání souborů došlo k chybě');
			$message_err = _('Error occured during files upload');
		};
		show_messages($result, $message_ok, $message_err);
	};
}	

$hostCount=-1;
$items = API::Item()->get([
	'output' => ['itemid'],
	'search' => ['key_' => HOST_COUNT_ITEMKEY],
	'templated' => false
]);
if(count($items)>0){
	$itemid=$items[0]['itemid'];
	//var_dump($itemid);
	$hostCountHistory = API::History()->get([
		'output' => 'extend',
		'itemids' => $itemid,
		'sortfield' => 'clock',
        'sortorder' => 'DESC',
        'limit' => 1
	]);
	//var_dump($hostCountHistory);
	if(count($hostCountHistory)>0){
		$hostCount=$hostCountHistory[0]['value'];
	}
}


/*
 * Display
 */

	/*
	$serviceStatusFull = shell_exec(HTTPD_STATUS);
	foreach(preg_split("/((\r?\n)|(\r\n?))/", $serviceStatusFull) as $line){
		if(preg_match("/^\s*Active/",$line)) { $serviceStatus = $line; }
	} 
	
	$currentCrt = shell_exec(CRT_CURRENT);
	*/

$data['valid']=false;
$data['licStatus']='License is missing';
$data['licVersion']='';
$data['licIssuedFor']='';
$data['licIssuedForVat']='';
$data['licIpAddress']='';
$data['licExpiration']='';
$data['elisaHostsLic']=0;
$data['elisaHostsNow']=$hostCount;

exec(ELISA_PRINTLIC_SCRIPT, $licPrint, $rc);
if($rc==0){
	$avalid = explode("=", $licPrint[0]);
	if(count($avalid)==2){
		if(count($avalid)==2 && $avalid[1]=="true"){$data['valid']=true;}
		$astatus = explode("=", $licPrint[1]); $data['licStatus']=$astatus[1];
		$aissuedfor = explode("=", $licPrint[2]); $data['licIssuedFor']=$aissuedfor[1];
		$aversion = explode("=", $licPrint[3]); $data['licVersion']=$aversion[1];
		$aipaddress = explode("=", $licPrint[4]); $data['licIpAddress']=$aipaddress[1];
		$aexpiration = explode("=", $licPrint[5]); $data['licExpiration']=$aexpiration[1];
		if(count($licPrint)>6){
			$aissuedforvat = explode("=", $licPrint[6]); $data['licIssuedForVat']=$aissuedforvat[1];
			$ahostcount = explode("=", $licPrint[7]); $data['elisaHostsLic']=$ahostcount[1];
			if($data['elisaHostsLic']<$data['elisaHostsNow']){$data['valid']=false;$data['licStatus']="Source host count exceeded";}
		}
	}else{
		$data['licStatus']=$licPrint[0];
	}
};


	

$data['backurl']='elisa_license.php'; 
//$data['currentCrt']=$currentCrt; 



// render view
$swupdateView = new CView('elisa.license', $data);
$swupdateView->render();
$swupdateView->show();




require_once dirname(__FILE__).'/include/page_footer.php';
