<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


require_once dirname(__FILE__).'/include/config.inc.php';
require_once dirname(__FILE__).'/include/js.inc.php';


$page['title'] = _('NTP');
$page['file'] = 'elisa_ntp.php';
$page['hist_arg'] = array();

require_once dirname(__FILE__).'/include/page_header.php';

$themes = array_keys(Z::getThemes());
$themes[] = THEME_DEFAULT;

// VAR	TYPE	OPTIONAL	FLAGS	VALIDATION	EXCEPTION
$fields = array(
	'ntpservers' => [T_ZBX_STR, O_OPT, null, null, null],
	'backurl' => [T_ZBX_STR, O_OPT, null, null, null],
	'update' => [T_ZBX_STR, O_OPT, P_SYS|P_ACT, null, null],
	'cancel' => [T_ZBX_STR, O_OPT, P_SYS, null, null]
);
check_fields($fields);



	
/*
 * Actions
 */
 
if(hasRequest('update') ){
	if(getRequest('ntpservers')!=""){
		$setservers = preg_replace('/\s+/', '', getRequest('ntpservers'));
		exec('sudo /usr/share/elisa/bin/elisa-setNtp.sh '.$setservers, $output, $rci);
		$result = false;
		if($rci==0){$result=true;}
		show_messages($result, _('NTP Configuration updated'), _('NTP Configuration update failed'));
	};
};

/*
 * Display
 */

	/*
	$serviceStatusFull = shell_exec(HTTPD_STATUS);
	foreach(preg_split("/((\r?\n)|(\r\n?))/", $serviceStatusFull) as $line){
		if(preg_match("/^\s*Active/",$line)) { $serviceStatus = $line; }
	} 
	
	$currentCrt = shell_exec(CRT_CURRENT);
	*/


$data = [];		
$data['ntpservers']='';
$ntpservers = [];	
exec("grep -e \"^server\" /etc/chrony.conf", $output, $rc1);
foreach($output as $line){
	preg_match('/^server\s+(\S+)\s+.*/', $line, $matches, PREG_OFFSET_CAPTURE);
	if( count($matches) == 2 ){
		$ntpservers[] = $matches[1][0];
	};
}
$data['ntpservers']=implode(",", $ntpservers);

	

$data['backurl']='elisa_ntp.php'; 


//var_dump($data);



// render view
$ntpView = new CView('elisa.ntp', $data);
$ntpView->render();
$ntpView->show();




require_once dirname(__FILE__).'/include/page_footer.php';
