<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/

define('CRT_DIRECTORY','/usr/share/elisa/portal/uploaded_crt');
define('CRT_UPLOAD_SCRIPT','sudo /usr/share/elisa/bin/elisa-crtUpload.pl > /dev/null 2>/dev/null &');
define('CRT_CURRENT','/usr/bin/openssl x509 -in /etc/pki/tls/certs/elisa.crt -noout -text');
//define('HTTPD_STATUS','/bin/systemctl status httpd.service | grep "Active"');

require_once dirname(__FILE__).'/include/config.inc.php';
require_once dirname(__FILE__).'/include/js.inc.php';


$page['title'] = _('ELISA SSL Certificates');
$page['file'] = 'elisa_ssl.php';
$page['hist_arg'] = array();

require_once dirname(__FILE__).'/include/page_header.php';

$themes = array_keys(Z::getThemes());
$themes[] = THEME_DEFAULT;

// VAR	TYPE	OPTIONAL	FLAGS	VALIDATION	EXCEPTION
$fields = array(
	'pfxpass' => [T_ZBX_STR, O_OPT, null, null, null],
	'backurl' => [T_ZBX_STR, O_OPT, null, null, null],
	'update' => [T_ZBX_STR, O_OPT, P_SYS|P_ACT, null, null],
	'cancel' => [T_ZBX_STR, O_OPT, P_SYS, null, null],
	'CN' =>	[T_ZBX_STR, O_OPT, null, NOT_EMPTY,	'isset({createcsr})', _('Common Name')],
	'O' =>	[T_ZBX_STR, O_OPT, null, NOT_EMPTY,	'isset({createcsr})', _('Organization')],
	'L' =>	[T_ZBX_STR, O_OPT, null, NOT_EMPTY,	'isset({createcsr})', _('City / Locality')],
	'ST' =>	[T_ZBX_STR, O_OPT, null, NOT_EMPTY,	'isset({createcsr})', _('State / Province')],
	'C' =>	[T_ZBX_STR, O_OPT, null, NOT_EMPTY,	'isset({createcsr})', _('Country')],
	'createcsr' => [T_ZBX_STR, O_OPT, null, null, null]
);
check_fields($fields);


if(hasRequest('createcsr') && getRequest('createcsr')=='Create' ){
	exec('/usr/bin/openssl genrsa -out /tmp/elisaWeb.key 2048 1> /dev/null 2>&1', $output, $rc1);
	exec('cp /etc/ssl/openssl.conf /tmp/opensslWeb.conf 1> /dev/null 2>&1', $output, $rc1);	
	exec('sed -i -e "s#^\s*O=.*#O='.getRequest('O').'#" /tmp/opensslWeb.conf 1> /dev/null 2>&1', $output, $rc1);
	exec('sed -i -e "s#^\s*L=.*#L='.getRequest('L').'#" /tmp/opensslWeb.conf 1> /dev/null 2>&1', $output, $rc1);
	exec('sed -i -e "s#^\s*ST=.*#ST='.getRequest('ST').'#" /tmp/opensslWeb.conf 1> /dev/null 2>&1', $output, $rc1);
	exec('sed -i -e "s#^\s*C=.*#C='.getRequest('C').'#" /tmp/opensslWeb.conf 1> /dev/null 2>&1', $output, $rc1);
	exec('sed -i -e "s#^\s*CN=.*#CN='.getRequest('CN').'#" /tmp/opensslWeb.conf 1> /dev/null 2>&1', $output, $rc1);
	exec('/usr/bin/openssl req -new -out /tmp/elisaWeb.csr -key /tmp/elisaWeb.key -config /tmp/opensslWeb.conf 1> /dev/null 2>&1', $output, $rc1);	
	exec('cd /tmp && rm -f /tmp/elisaWeb.zip && /usr/bin/zip elisaWeb.zip elisaWeb.csr elisaWeb.key 1> /dev/null 2>&1', $output, $rc1);	
	
	ob_end_clean();
    $attachment_location = "/tmp/elisaWeb.zip";
	header($_SERVER["SERVER_PROTOCOL"] . " 200 OK");
    header("Cache-Control: public"); // needed for internet explorer
    header("Content-Type: application/zip");
    header("Content-Transfer-Encoding: Binary");
    header("Content-Length:".filesize($attachment_location));
    header("Content-Disposition: attachment; filename=elisaWeb.zip");
    readfile($attachment_location);
	exit;
};

function checkPEM(){
	$rc=0;
	exec('/usr/bin/openssl rsa -in '.CRT_DIRECTORY.'/elisa.key -check', $output, $rc1);
	exec('/usr/bin/openssl x509 -in '.CRT_DIRECTORY.'/elisa.crt -noout -text', $output, $rc2);
	
	exec('openssl rsa  -noout -modulus -in '.CRT_DIRECTORY.'/elisa.key | openssl md5', $KEYHASH, $rc3);
	exec('openssl x509 -noout -modulus -in '.CRT_DIRECTORY.'/elisa.crt | openssl md5', $CRTHASH, $rc4);
	$rc5 = 0;
	# porovnani otisku
	if ( $KEYHASH != $CRTHASH ){$rc5=1;}

	$rc = $rc1+$rc2+$rc3+$rc4+$rc5;
	return $rc;
};	

	
/*
 * Actions
 */

$result = true;
	if(sizeof($_FILES)>0){
		
		if(isset($_FILES['keyfile']) && isset($_FILES['crtfile'])){
			$uploadmessagePEM_ok = '';
			$uploadmessagePEM_err = '';
			if($_FILES['keyfile']['error']==0 && $_FILES['crtfile']['error']==0){
				if (move_uploaded_file($_FILES['keyfile']['tmp_name'], CRT_DIRECTORY."/elisa.key") && move_uploaded_file($_FILES['crtfile']['tmp_name'], CRT_DIRECTORY."/elisa.crt")) {
					if(checkPEM()==0){
						$crtUploadStatus = shell_exec(CRT_UPLOAD_SCRIPT);
						$result = true;
						//$uploadmessagePEM_ok = _('Certifikát byl úspěšně načten. Jeho instalace proběhne během 10s.');		
						$uploadmessagePEM_ok = _('Certificate has been sucessfully uploaded. Installation will be done within 10s.');		
						add_audit_details(AUDIT_ACTION_UPDATE, 99, 0, $_FILES['crtfile']['name'], 'ssl-certificate');
					}else{
						if(file_exists(CRT_DIRECTORY.'/elisa.key')){unlink(CRT_DIRECTORY.'/elisa.key');};
						if(file_exists(CRT_DIRECTORY.'/elisa.crt')){unlink(CRT_DIRECTORY.'/elisa.crt');};						
						//$uploadmessagePEM_err = _('Certifikát nebo klíč je poškozen.');
						$uploadmessagePEM_err = _('Certificate or key file is corrupted..');
						$result = false;
					}
				} else {
					//$uploadmessagePEM_err = _('Při nahrávání souborů došlo k chybě');
					$uploadmessagePEM_err = _('Error occured during files upload');
					$result = false;
				};						
			}else{
				$result = false;
				//$uploadmessagePEM_err = _('Při nahrávání souborů došlo k chybě');
				$uploadmessagePEM_err = _('Error occured during files upload');
			};
			exec('sudo /usr/share/elisa/bin/elisa-clusterSync.sh', $output, $rci);
			show_messages($result, $uploadmessagePEM_ok, $uploadmessagePEM_err);
		};
		
		if(isset($_FILES['pfxfile'])){
			$uploadmessagePFX_ok = '';
			$uploadmessagePFX_err = '';
			if($_FILES['pfxfile']['error']==0){
				if (move_uploaded_file($_FILES['pfxfile']['tmp_name'], CRT_DIRECTORY."/elisa.pfx")) {
					$pfxExportStatus = shell_exec('/usr/bin/openssl pkcs12 -in '.CRT_DIRECTORY.'/elisa.pfx -out '.CRT_DIRECTORY.'/elisa.key -nodes -nocerts -password pass:'.$_POST["pfxpass"]);
					$pfxExportStatus = shell_exec('/usr/bin/openssl pkcs12 -in '.CRT_DIRECTORY.'/elisa.pfx -out '.CRT_DIRECTORY.'/elisa.crt -nodes -nokeys -password pass:'.$_POST["pfxpass"]);
					if(checkPEM()==0){
						$crtUploadStatus = shell_exec(CRT_UPLOAD_SCRIPT);
						$result = true;
						//$uploadmessagePFX_ok =  _('Certifikát byl úspěšně načten. Jeho instalace proběhne během 10s.');	
						$uploadmessagePFX_ok = _('Certificate has been sucessfully uploaded. Installation will be done within 10s.');								
						add_audit_details(AUDIT_ACTION_UPDATE, 99, 0, $_FILES['pfxfile']['name'], 'ssl-certificate');
					}else{
						if(file_exists(CRT_DIRECTORY.'/elisa.key')){unlink(CRT_DIRECTORY.'/elisa.key');};
						if(file_exists(CRT_DIRECTORY.'/elisa.crt')){unlink(CRT_DIRECTORY.'/elisa.crt');};						
						$result = false;
						//$uploadmessagePFX_err =  _('Při exportu PFX došlo k chybě');
						$uploadmessagePFX_err =  _('Error occured during PFX file unpacking');
					}
				} else {
					$result = false;
					//$uploadmessagePFX_err =  _('Při nahrávání souboru došlo k chybě');
					$uploadmessagePFX_err =  _('Error occured during file upload');
				};						
			}else{
				$result = false;
				//$uploadmessagePFX_err =  _('Při nahrávání souboru došlo k chybě');
				$uploadmessagePFX_err =  _('Error occured during file upload');
			};	
			if(file_exists(CRT_DIRECTORY.'/elisa.pfx')){unlink(CRT_DIRECTORY.'/elisa.pfx');};	
			exec('sudo /usr/share/elisa/bin/elisa-clusterSync.sh', $output, $rci);			
			show_messages($result, $uploadmessagePFX_ok, $uploadmessagePFX_err);
		}
	}	


/*
 * Display
 */

	/*
	$serviceStatusFull = shell_exec(HTTPD_STATUS);
	foreach(preg_split("/((\r?\n)|(\r\n?))/", $serviceStatusFull) as $line){
		if(preg_match("/^\s*Active/",$line)) { $serviceStatus = $line; }
	} 
	
	$currentCrt = shell_exec(CRT_CURRENT);
	*/

$data = [];		
$data['web']['O']='';
$data['web']['L']='';
$data['web']['ST']='';
$data['web']['C']='';
$data['web']['CN']='';
	exec(CRT_CURRENT, $output, $rc2);
	foreach($output as $line){
		if( strpos($line, 'Subject: ') !== false){
			preg_match('/O=(.*),\s*L=(.*),\s*ST=(.*),\s*C=(.*),\sCN=(.*)/', $line, $matches, PREG_OFFSET_CAPTURE);
			if( count($matches) == 6 ){
				$data['web']['O'] = $matches[1][0];
				$data['web']['L'] = $matches[2][0];
				$data['web']['ST'] = $matches[3][0];
				$data['web']['C'] = $matches[4][0];
				$data['web']['CN'] = $matches[5][0];
			};
		}
	}

	

$data['backurl']='elisa_ssl.php'; 
//$data['currentCrt']=$currentCrt; 



// render view
$sslView = new CView('elisa.ssl', $data);
$sslView->render();
$sslView->show();




require_once dirname(__FILE__).'/include/page_footer.php';
