<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


require_once dirname(__FILE__).'/include/config.inc.php';
require_once dirname(__FILE__).'/include/js.inc.php';


$page['title'] = _('ELISA Syslog configuration');
$page['file'] = 'elisa_syslog.php';
$page['hist_arg'] = array();

require_once dirname(__FILE__).'/include/page_header.php';

$themes = array_keys(Z::getThemes());
$themes[] = THEME_DEFAULT;

// VAR	TYPE	OPTIONAL	FLAGS	VALIDATION	EXCEPTION
$fields = array(
	'relp01enable' => [T_ZBX_STR, O_OPT, null, null, null],
	'relp01port' => [T_ZBX_STR, O_OPT, null, null, null],
	'relp02enable' => [T_ZBX_STR, O_OPT, null, null, null],
	'relp02port' => [T_ZBX_STR, O_OPT, null, null, null],
	'update' => [T_ZBX_STR, O_OPT, P_SYS|P_ACT, null, null],
	'cancel' => [T_ZBX_STR, O_OPT, P_SYS, null, null]
);
check_fields($fields);




	
/*
 * Actions
 */

if(hasRequest('update')){
	if(hasRequest('relp01enable') || hasRequest('relp02enable')){
		$fileContent = '';
		$file = fopen("/etc/rsyslog.d/relp.00.conf.template","r");
		while(! feof($file)){
			$line = fgets($file);
			$l = $line;
			$fileContent = $fileContent.$l;
		}
		fclose($file);	
		$result = file_put_contents("/etc/rsyslog.d/relp.00.conf",$fileContent);
	}else{
		shell_exec("> /etc/rsyslog.d/relp.00.conf");
		shell_exec("> /etc/rsyslog.d/relp.01.conf");
		shell_exec("> /etc/rsyslog.d/relp.02.conf");
		add_audit_details(AUDIT_ACTION_DELETE, 99, 0, 'RELP', 'syslog-relp');
		add_audit_details(AUDIT_ACTION_DELETE, 99, 0, 'RELP TLS', 'syslog-relp');
	}
	if(hasRequest('relp01enable')){
		$fileContent = '';
		$file = fopen("/etc/rsyslog.d/relp.01.conf.template","r");
		while(! feof($file)){
			$line = fgets($file);
			$l = $line;
			if(strpos($l, "port=") !== FALSE){$l = "        port=\"".getRequest('relp01port')."\"\n"; }
			$fileContent = $fileContent.$l;
		}
		fclose($file);	
		$result = file_put_contents("/etc/rsyslog.d/relp.01.conf",$fileContent);
		add_audit_details(AUDIT_ACTION_ADD, 99, 0, 'RELP '.getRequest('relp01port'), 'syslog-relp');
	}
	if(hasRequest('relp02enable')){
		$fileContent = '';
		$file = fopen("/etc/rsyslog.d/relp.02.conf.template","r");
		while(! feof($file)){
			$line = fgets($file);
			$l = $line;
			if(strpos($l, "port=") !== FALSE){$l = "        port=\"".getRequest('relp02port')."\"\n"; }
			$fileContent = $fileContent.$l;
		}
		fclose($file);	
		$result = file_put_contents("/etc/rsyslog.d/relp.02.conf",$fileContent);
		add_audit_details(AUDIT_ACTION_ADD, 99, 0, 'RELP TLS '.getRequest('relp02port'), 'syslog-relp');
	}
	shell_exec("sudo systemctl restart rsyslog");
}

/*
 * Display
 */

function getRelpConf($v){
	$port = 20514; if ($v == "02"){ $port=21514; }
	$relp=["enabled"=>false,"port"=>$port];
	exec('grep port /etc/rsyslog.d/relp.'.$v.'.conf | tr -s " " | cut -d= -f2 | cut -d\'"\' -f2', $output, $rc1);
	if(count($output)==1){
		$relp["enabled"]=true;
		$relp["port"]=$output[0];
	}else{
		$relp["enabled"]=false;
		exec('grep port /etc/rsyslog.d/relp.'.$v.'.conf.template | tr -s " " | cut -d= -f2 | cut -d\'"\' -f2', $output, $rc1);
		if(count($output)==1){
			$relp["port"]=$output[0];
		}
	}
	return $relp;
};	

$relp01 = getRelpConf("01");
$relp02 = getRelpConf("02");

$data = [];
$data['relp01'] = $relp01;
$data['relp02'] = $relp02;		
$data['backurl'] = $page['file'];
$sslView = new CView('elisa.syslog', $data);
$sslView->render();
$sslView->show();




require_once dirname(__FILE__).'/include/page_footer.php';
