<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


$bucketTitle = '';

if($this->data['bucket']['show'] != ""){
	if(isset($this->data['bucket']['config'][$this->data['bucket']['show']])){
		if($this->data['bucket']['config'][$this->data['bucket']['show']]['ALIAS'] != ''){
			$bucketTitle = ' - '._('Logstorage').' '.$this->data['bucket']['config'][$this->data['bucket']['show']]['ALIAS'];
		}else{
			$bucketTitle = ' - '._('Logstorage').' '.$this->data['bucket']['show'];
		}
	}else{
		$bucketTitle = ' - '._('Logstorage').' '.$this->data['bucket']['show'];
	}
	
}



$indicename = 'elisa'.$this->data['bucket']['show'];

$missing = [];
$indiceprev = date_create_from_format("Y.m.d",date("Y.m.d"));
foreach($this->data['indice'] as $key => $indice){
	$indicedate = explode('-', $key)[1];
	$indicedate = date_create_from_format("Y.m.d",$indicedate);
	$diff = date_diff($indicedate,$indiceprev);	
	$diffdays = $diff->{'days'};	
	//echo $key.' - '.$diffdays."<br/>";
	if($diffdays > 1){
		$indicedateadd = clone $indiceprev;
		for ($i = $diffdays-1; $i > 0; $i--) {
			date_add($indicedateadd,date_interval_create_from_date_string("-1 days"));
			$missing[] = $indicename.'-'.date_format($indicedateadd,"Y.m.d");
		}		
	}
	$indiceprev = $indicedate;
	
}

$indicesWidget = (new CWidget())->setTitle(_('ELISA DB Indices'.$bucketTitle));

$infoTab = new CTabView();
$infoDiv = new CDiv();
$infoDiv->addItem( (new CTag('h3',true,_('Missing indices'))) );
$infoDiv->addItem( _('Missing indices are listed below. You can create empty indices to enable searching through this time interval.') );
$infoDiv->addItem( new CTag('br') )->addItem( new CTag('br') );
$infoDiv->addItem( (new CButtonCancel()) );

$infoTab->addTab('info','info',$infoDiv);
$indicesWidget->addItem($infoTab);

//$indicesWidget->addItem((new CTag('h4',true,_('Missing indices'))));
$indicesForm = (new CForm())->setName('indicesForm');

// create user group table
$indicesTable = new CTableInfo(_('No missing DB indices found.'));
$indicesTable->setHeader(array(
	(new CColHeader(
			(new CCheckBox('all_indices'))->onClick("checkAll('".$indicesForm->getName()."','all_indices','mindicesid');")
		))->addClass(ZBX_STYLE_CELL_WIDTH),
	_('Name')
));
foreach ($missing as $name) {
	$checkbox = new CCheckBox('mindicesid['.$name.']', $name);
	$indicesTable->addRow(array(
		$checkbox,
		new CCol($name, 'wraptext')
	));
}

zbx_add_post_js('cookie.prefix = "mindicesid";');

$actionList = new CActionButtonList('action', 'mindicesid',
	[
		'indices.masscreate' => ['name' => _('Create'), 'confirm' => _('Create selected indices?')]
	],
	'mindicesid'
);

$indicesForm->addItem([
	$indicesTable, 
	$actionList
	
]);

$indicesWidget->addItem($indicesForm);

return $indicesWidget;
