<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


$networkWidget = (new CWidget())->setTitle(_('Network Configuration'));

$data = $this->data;

$interface_row = (new CList())->addClass(ZBX_STYLE_LIST_CHECK_RADIO);
foreach ($data['ifs'] as $i => $if) {
	if( ! $if['bond'] ){
		$checked=false;
		$enabled=true;
		if( $if['slave'] && $if['master']==$data['bonding']['name'] ){ $checked=true; }
		if( $if['slave'] && $if['master']!=$data['bonding']['name'] ){ $enabled=false; }
		$interface_row->addItem(
			(new CCheckBox('if['.$i.']', $if['name']))
				->setLabel($if['name'])
				->setChecked($checked)
				->setEnabled($enabled)
		);
	}
}

$bondForm = (new CForm())
	->setName('bondingForm')
	->setAttribute('aria-labeledby', ZBX_STYLE_PAGE_TITLE)
	->addVar('form', 'bondingEdit');

$bondFormDiv = new CDIV();
$bondFormList = (new CFormList())
	->addRow(
		(new CLabel(_('Bonding name'), 'bond'))->setAsteriskMark(),
		(new CTextBox('bond', $data['bonding']['name']))
			->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)
			->setAriaRequired()
			->setAttribute('autofocus', 'autofocus')
			->setAttribute('maxlength', 10)
	)
	->addRow(
		(new CLabel(_('Interfaces'), 'if'))->setAsteriskMark(),
		$interface_row
	);


$bondFormDiv->addItem($bondFormList);


$bondTab = (new CTabView())
	->addTab('bondTab', _('Bonding'), $bondFormDiv);

if ($data['bonding']['name'] != '') {
	$bondTab->setFooter(makeFormFooter(
		new CSubmit('updateBonding', _('Update')),
		[
			new CButtonCancel()
		]
	));
}
else {
	$bondTab->setFooter(makeFormFooter(
		new CSubmit('createBonding', _('Add')),
		[new CButtonCancel()]
	));
}


$bondForm->addItem($bondTab);

// append form to widget
$networkWidget->addItem($bondForm);



//require_once dirname(__FILE__).'/js/elisa.network.js.php';


return $networkWidget;
