<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


$networkWidget = (new CWidget())->setTitle(_('Network Configuration'));


$networkTab = new CTabView();

	$ifs = $this->data['ifs'];
	$routes = $this->data['route'];
	
	$networkHostnameForm = (new CForm())->setName('networkHostnameForm');
	$hostnameFormList = (new CFormList())
	->addRow(
		(new CLabel(_('Hostname'), 'hostname'))->setAsteriskMark(),
		(new CTextBox('hostname', $data['hostname']))
			->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)
			->setAriaRequired()
			->setAttribute('autofocus', 'autofocus')
			->setAttribute('maxlength', 50)
	);
	
	$networkHostnameForm->addItem($hostnameFormList);
	$networkHostnameForm->addItem(makeFormFooter(new CSubmit('updateHostname', _('Update')), [ new CButtonCancel() ]));
		
	$networkTab->addTab('hostnameTab', _('Hostname'), $networkHostnameForm);
	
	
	
	
	$networkIfForm = (new CForm())->setName('networkIfForm');
	
	if($data['redirect']!=""){ 
		$networkIfForm->addItem((new CInput('hidden','network-redirect-ip',$data['redirect']))); 
		$networkTab->addClass('in-progress');
	}

		$ifTable = (new CTableInfo()); //->addStyle('width:0;');
		$ifTable->setHeader(array(_('Interface'),_('Enabled'),_('IP'),_('Netmask'),_('Gateway')));
		foreach ($ifs as $i => $if) {
			
			if(! $if['slave']){
				$name = (new CSpan)
					->addItem($if['name'])
					->addItem(new CInput('hidden','if['.$i.'][name]',$if['name']));
				
				if( $if['gateway'] == "" ){
					$enabled = (new CRadioButtonList('if['.$i.'][enabled]', (int) $if['enabled']))
					->addValue(_('yes'), 1)
					->addValue(_('no'), 0)
					->setModern(true);
				}else{
					$enabled = (new CSpan)
						->addItem(_('yes'))
						->addItem(new CInput('hidden','if['.$i.'][enabled]',1));
					
				}
				
				$ip = (new CTextBox('if['.$i.'][ip]', $if['ip'],false))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH);
				$mask = (new CTextBox('if['.$i.'][mask]', $if['mask'],false))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH);
				
				if( $if['gateway'] != "" ){
					$gateway = (new CTextBox('if['.$i.'][gateway]', $if['gateway'],false))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH);
				}else{
					$gateway = new CInput('hidden','if['.$i.'][gateway]','');
				}

				$ifTable->addRow(array($name,$enabled,$ip,$mask,$gateway));
			}
		}

		$networkIfForm->addItem($ifTable);
		
		$buttons = [ new CButtonCancel() ];

		$networkIfForm->addItem(makeFormFooter(new CSubmit('updateNetwork', _('Update')), $buttons));



	$networkTab->addTab('ifs', _('Interfaces'), $networkIfForm);
	


	$networksRouteForm = (new CForm())->setName('networkRoutingForm');

		$routeTable = (new CTableInfo())
			->setId('tbl_elisa_route')
			->setHeader([
				_('Destination'),
				_('Netmask'),
				_('Gateway'),
				_('Interface'),
				_('Action')
			]);

		foreach ($routes as $i => $route) {

			$destination = (new CTextBox('route['.$i.'][destination]', $route->{'destination'},false))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH);
			$mask = (new CTextBox('route['.$i.'][mask]', $route->{'mask'},false))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH);
			$gateway = (new CTextBox('route['.$i.'][gateway]', $route->{'gateway'},false))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH);
			
			$if = (new CRadioButtonList('route['.$i.'][if]',$route->{'if'}))->setModern(true);
			foreach($data['interfaces'] as $interface){ $if->addValue($interface,$interface); }

			$row = array($destination,$mask,$gateway,$if);

			$button_cell = [
				(new CButton('route['.$i.'][remove]', _('Remove')))
					->addClass(ZBX_STYLE_BTN_LINK)
					->addClass('element-table-remove')
			];
			$button_cell[] = new CVar('route['.$i.']', null);

			$row[] = (new CCol($button_cell))->addClass(ZBX_STYLE_NOWRAP);
			
			$routeTable->addRow((new CRow($row))  
				->addClass('form_row')
				->setAttribute('data-index', $i)
			) ;
			

		}

		$routeTableAddLine = (new CButton('expression_add', _('Add')))
				->addClass(ZBX_STYLE_BTN_LINK)
				->addClass('element-table-add');
				
		$routeTable->setFooter($routeTableAddLine);

		$networksRouteForm->addItem($routeTable);
		//$networksRouteForm->addItem($routeTableAddLine);
		
		
		$buttons = [ new CButtonCancel() ];

		$networksRouteForm->addItem(makeFormFooter(new CSubmit('updateRoute', _('Update')), $buttons));
	
	
	$networkTab->addTab('routing', _('Routing'), $networksRouteForm);


	$networksBondingForm = (new CForm())->setName('networkRoutingForm')
		->addStyle("position:relative");

		$bondTable = (new CTableInfo())
			->setId('tbl_elisa_bond')
			->setHeader([
				_('Name'),
				_('Interfaces'),
				_('Action')
			]);

		foreach ($ifs as $i => $if) {
			
			if( $if['bond']){
				$name = $if['name'];
				$bondif = [];
				foreach ($ifs as $i => $ifslave) {
					if( $ifslave['master'] == $name ){ $bondif[] = $ifslave['name']; }
				}
				$interfaces = implode(",",$bondif);
				$action = (new CSpan);
				/*$action->addItem((new CButton('editBondingForm',_('Edit')))
					->onClick('window.location.href="elisa_network.php?createBondingForm=1&bond='.$name.'";')
					);*/
				$action->addItem((new CButtonQMessage('removeBonding',_('Remove'),_('Do you really want to remove bonding \''.$name.'\'?'),'&bond='.$name))
					->addStyle('margin-left:10px;')
					);
				$bondTable->addRow(array($name,$interfaces,$action));
			}
		
		}
		
		$networksBondingForm->addItem(
			(new CButton('createBondingForm',_('Create bonding')))
				->onClick('window.location.href="elisa_network.php?createBondingForm=1";')
				->addStyle('position:absolute;top:2px;right:2px;')
		);				

		$networksBondingForm->addItem($bondTable);
		$popup_options = [
			'dstfrm' => $networksBondingForm->getName(),
			'name' => '',
			'ifs' => [],
			'ifs_all' => $ifs
		];

		//$networksRouteForm->addItem($routeTableAddLine);
		
		
		/*$buttons = [ new CButtonCancel() ];
		$networksBondingForm->addItem(makeFormFooter(new CSubmit('updateRoute', _('Update')), $buttons));*/
	
	
	$networkTab->addTab('bonding', _('Bonding'), $networksBondingForm);
	

// append form to widget
$networkWidget->addItem($networkTab);

$routeIfPrototype = $if = (new CRadioButtonList('route[#{rowNum}][if]',$data['interfaces'][0]))->setModern(true);
foreach($data['interfaces'] as $interface){ $routeIfPrototype->addValue($interface,$interface); }

require_once dirname(__FILE__).'/js/elisa.network.js.php';


return $networkWidget;
