<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


/* WIDGET - CELA STRANKA*/
$sslWidget = (new CWidget())->setTitle(_('ELISA SSL Certificates'));

/* TABY PRES CELOU STRANKU */
$sslTab = new CTabView();

	/* OBSAH TABU "WEB" */
	/* DIV s obsahem tabu WEB */
	$webDiv = new CDiv();

	//$webDiv->addItem((new CTag('h1',true,_('SSL certifikát webového rozhraní ELISA'))));
	//$webDiv->addItem((new CTag('h1',true,_('SSL certificate of ELISA web interface'))));
	//$webDiv->addItem((new CDiv(_('SSL certifikát je využíván pro zabezpečení komunikace mezi webovým prohlížečem a serverem. Zde můžete nahrát soubor nového certifikátu, tj. obvykle certifikátu podepsaného důvěryhodnou certifikační autoritou. Importovaný certifikát může být v PFX / PKCS#12 formátu nebo v PEM formátu. Po nahrání certifikátu dojde během 10 sekund ke změně konfigurace webového serveru. Detaily aktuálně použitého certifikátu můžete ověřit níže.'))));
	$webDiv->addItem((new CDiv(_('SSL certificate is used to secure communications between the web browser and the server. Here you can upload a new certificate, usually certificate signed by a trusted certificate authority. Imported certificate can be in the PFX / PKCS#12 format or in PEM format. The web server configuration change occurs within 10 seconds after uploading the certificates. You can also view details of the current certificate.'))));
	$webDiv->addItem((new CTag('br')));
	//$webDiv->addItem((new CButton('web_current', _('Aktuální certifikát')))
	$webDiv->addItem((new CButton('web_current', _('Show current certificate')))
					->onClick('PopUpOld("elisa_ssl_web_curr.php?fullscreen=1")'));
	$webDiv->addItem((new CTag('br')));
	$webDiv->addItem((new CTag('br')));
	$webDiv->addItem((new CTag('br')));


	/* TAB s formularema pro PEM a PFX */
	$webFormTab = new CTabView();

		$webFormREQ = new CForm('post', null);
			$webFormListREQ = (new CFormList());
			$webFormListREQ->addRow(_('Common Name'), new CTextBox('CN', $data['web']['CN'], false, ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormListREQ->addRow(_('Organization'), new CTextBox('O', $data['web']['O'], false, ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormListREQ->addRow(_('City / Locality'), new CTextBox('ST', $data['web']['ST'], false, ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormListREQ->addRow(_('State / Province'), new CTextBox('L', $data['web']['L'], false, ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormListREQ->addRow(_('Country'), new CTextBox('C', $data['web']['C'], false, ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormREQ->addItem($webFormListREQ);
			$webFormREQ->addItem(makeFormFooter(
				new CSubmit('createcsr', _('Create')),
				[new CRedirectButton(_('Cancel'), $data['backurl'])]
			));
			$webFormTab->addTab('webREQ', _('Request'), $webFormREQ);
	
		$webFormPEM = new CForm('post', null, 'multipart/form-data');
			//$webFormPEM->addItem((new CTag('h2',true,_('Nahrát soubory ve formátu PEM'))));
			//$webFormPEM->addItem((new CTag('h2',true,_('Import certificate in PEM format'))));
			$webFormListPEM = (new CFormList());
			//$webFormListPEM->addRow(_('Privátní klíč (.key)'), (new CFile('keyfile'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormListPEM->addRow(_('Private key (.key)'), (new CFile('keyfile'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
			//$webFormListPEM->addRow(_('Certifikát (.crt)'), (new CFile('crtfile'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormListPEM->addRow(_('Certificate file (.crt)'), (new CFile('crtfile'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormPEM->addItem($webFormListPEM);
			$webFormPEM->addItem(makeFormFooter(
				new CSubmit('update', _('Update')),
				[new CRedirectButton(_('Cancel'), $data['backurl'])]
			));
			$webFormTab->addTab('webPEM', _('PEM'), $webFormPEM);


		$webFormPFX = new CForm('post', null, 'multipart/form-data');
			//$webFormPFX->addItem((new CTag('h2',true,_('Nahrát soubory ve formátu PFX / PKCS#12'))));
			//$webFormPFX->addItem((new CTag('h2',true,_('Import certificate in PFX / PKCS#12 format'))));
			$webFormListPFX = (new CFormList());
			//$webFormListPFX->addRow(_('PFX / PKCS12 soubor (.pfx/.p12)'), (new CFile('pfxfile'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormListPFX->addRow(_('PFX / PKCS12 file (.pfx/.p12)'), (new CFile('pfxfile'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
			//$webFormListPFX->addRow(_('Heslo, pokud je soubor chráněn'), (new CPassBox('pfxpass'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormListPFX->addRow(_('Password, if certificate is protected'), (new CPassBox('pfxpass'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
			$webFormPFX->addItem($webFormListPFX);
			$webFormPFX->addItem(makeFormFooter(
				new CSubmit('update', _('Update')),
				[new CRedirectButton(_('Cancel'), $data['backurl'])]
			));
			$webFormTab->addTab('webPFX', _('PFX/PKCS#12'), $webFormPFX);


	$webDiv->addItem($webFormTab);


$sslTab->addTab('web', _('Web SSL'), $webDiv);



//dalsi TAB
//$sslTab->addTab('web2', _('Web SSL 2'), null);





// append form to widget
$sslWidget->addItem($sslTab);

return $sslWidget;
