<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


/* WIDGET - CELA STRANKA*/
$swupdateWidget = (new CWidget())->setTitle(_('ELISA Software Update'));


function getYesNo($val){
	if($val==1){
		return (new CSpan(_('Yes')))->AddClass('green');
	}else{
		return (new CSpan(_('No')))->AddClass('red');		
	}
}

function getValueOrNo($val){
	if($val==""){
		return (new CSpan(_('No')))->AddClass('red');		
	}else{
		return (new CSpan($val))->AddClass('white');		
	}
}

/* TABY PRES CELOU STRANKU */
$swupdateTab = new CTabView();

	/* OBSAH TABU "WEB" */
	/* DIV s obsahem tabu WEB */
	$formDiv = new CDiv();
	
	$formDiv->addItem((new CTag('h3',true))->addItem(_('ELISA Version')));
	$formDiv->addItem((new CTag('br')));
	
	$versionDiv = (new CDiv())
		->AddStyle('padding-left:30px;')
		->addItem( (new CSpan(_('Current version: '))) )
		->addItem( (new CSpan($data['elisa_version'])) );

	if($data['uninstall']){
		$versionDiv->addItem((new CButtonQMessage('downgrade',_('Uninstall'),_('Do you really want to downgrade to version')." '".$data['prevversion']."'?\n"._('This is the last chance to stop downgrade process...'),'_'.$data['uninstall']))->AddStyle('margin-left:10px;'));
	};
	$formDiv->addItem($versionDiv);
					
	$formDiv->addItem((new CTag('br')));
	$formDiv->addItem((new CDiv(_('Available patches: ')))->AddStyle('padding-left:30px;'));
	$formDiv->addItem((new CPre(file_get_contents($this->data['configValues']['ELISA_AVAILABLE_PATCHES'])))->AddStyle('padding:10px 0 0 50px;'));
	$formDiv->addItem((new CTag('br')));
	
	
	
	$formDiv->addItem((new CTag('h3',true))->addItem(_('Automatic updates settings')));
	$formDiv->addItem((new CTag('br')));
	$configTableForm = new CForm('post', null);
	$configTable = (new CTableInfo())->AddStyle('width:auto;margin-left:25px;');
	$configTable->addRow([(new CSpan(_('Install OS Security patches automatically:'))),getYesNo($this->data['configValues']['UPDATE_OS_SECURITY']),(new Clink(_('Update now'),'elisa_swupdate.php?action=update1'))->addConfirmation(_('OS update will be iniciated. It can take few minutes and may be finished with OS restart. Continue?'))]);
	$configTable->addRow([(new CSpan(_('Install all OS packages updates automatically:'))),getYesNo($this->data['configValues']['UPDATE_OS_ALL']),(new Clink(_('Update now'),'elisa_swupdate.php?action=update2'))->addConfirmation(_('OS update will be iniciated. It can take few minutes and may be finished with OS restart. Continue?'))]);
	$configTable->addRow([(new CSpan(_('Install ELISA patches automatically:'))),getYesNo($this->data['configValues']['UPDATE_ELISA']),(new Clink(_('Update now'),'elisa_swupdate.php?action=update3'))->addConfirmation(_('ELISA update will be iniciated. It can take few minutes and may be finished with OS restart. Continue?'))]);
	$configTable->addRow([(new CSpan(_('Gather ELISA patch installation log:'))),getYesNo($this->data['configValues']['UPDATE_ELISA_LOGUPLOAD']),new CSpan('')]);
	$configTable->addRow([
		(new CSpan(_('Use http_proxy'))),
		//getValueOrNo($this->data['configValues']['HTTPPROXY']),
		(new CTextBox('http_proxy', $this->data['configValues']['HTTPPROXY']))
		->setWidth(ZBX_TEXTAREA_SMALL_WIDTH),
		(new CDiv())
			->AddItem((new Clink(_('Update'),'javascript:window.location.href = "elisa_swupdate.php?action=updateproxy&http_proxy="+document.getElementById("http_proxy").value;'))->addConfirmation(_('Update http_proxy?')))
		]);
	$configTableForm->addItem($configTable);
	$formDiv->addItem($configTableForm);
	//$formDiv->addItem((new CTag('br')));
	//$formDiv->addItem((new CDiv(_('* Automatic updates require valid ELISA license.')))->AddStyle('padding-left:30px;color:#737373;'));
	$formDiv->addItem((new CTag('br')));
	$formDiv->addItem((new CTag('br')));
	
	$formDiv->addItem((new CTag('h3',true))->addItem(_('Manual ELISA update')));
	$formDiv->addItem((new CTag('br')));
	$formDiv->addItem((new CDiv(_('On this page you can initiate the upgrade of your ELISA server. Please upload the PGP signed patch file from the manufacturer.')))->AddStyle('padding-left:30px;'));
	$formDiv->addItem((new CTag('br')));

	
	$formForm = new CForm('post', null, 'multipart/form-data');

		$formFormList = (new CFormList());
		$formFormList->addRow(_('Patch file:'), (new CFile('patchfile'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
		$formForm->addItem($formFormList);
		$formForm->addItem(makeFormFooter(
			new CSubmit('update', _('Update')),
			[new CRedirectButton(_('Cancel'), $data['backurl'])]
		));
	$formDiv->addItem($formForm);
	
	//var_dump($data);
	
	if(isset($data['patchfile'])){
		$resultDiv = new CDiv();
		$resultDiv->addItem((new CTag('br')));
		$resultDiv->addItem((new CTag('br')));
		$resultDiv->addItem((new CTag('hr')));
		$resultDiv->addItem((new CTag('br')));
		if($data['rc']==0){
			$title = (new CTag('h2',true));
			$title->addItem((new CTag('span',true,_('Patch '.$data['patchfile'].' has been installed '))));
			$title->addItem((new CTag('span',true,_('SUCCESFULLY')))->AddClass('green'));
			$resultDiv->addItem($title);
		}else{
			$title = (new CTag('h2',true));
			$title->addItem((new CTag('span',true,_('Patch '.$data['patchfile'].' installation '))));
			$title->addItem((new CTag('span',true,_('FAILED')))->AddClass('red'));
			$resultDiv->addItem($title);			
		}
		$resultDiv->addItem((new CTag('br')));
		foreach ($data['output'] as $line) {
			if($line==''){
				$resultDiv->addItem((new CTag('br')));
			}else{
				$resultDiv->addItem((new CDiv($line)));			
			}
		}
		$formDiv->addItem($resultDiv);
	}
	
$swupdateTab->addTab('form', _('Form'), $formDiv);











// append form to widget
$swupdateWidget->addItem($swupdateTab);

return $swupdateWidget;
