<?php
/*
** Zabbix
** Copyright (C) 2001-2019 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


function makeToolsMenu($selected) {
	return new CComboBox('configDropDown', $selected, 'redirect(this.options[this.selectedIndex].value);', [
		'elisa.tools.password.php' => _('Password encryption')
	]);
}


$widget = (new CWidget())
	->setTitle(_('Password encryption'))
	->setControls((new CTag('nav', true,
		(new CForm())
			->cleanItems()
			->addItem((new CList())
				->addItem(makeToolsMenu('elisa.tools.password.php'))
			)
		))
		->setAttribute('aria-label', _('Content controls'))
	);

$guiTab = (new CFormList())
	->addRow(_('Password'),
		new CTextBox('PASSWORD', $data['password'], false, ZBX_TEXTAREA_STANDARD_WIDTH)
	)
	->addRow(_('Key'),
		new CTextBox('KEY', $data['key'], false, ZBX_TEXTAREA_STANDARD_WIDTH)
	)
	->addRow(_('Encrypted password'),
		(new CSpan($data['encrypted']))->addClass(ZBX_STYLE_GREEN)
	);

$guiView = (new CTabView())
	->addTab('passwd', _('Password encryption'), $guiTab)
	->setFooter(makeFormFooter(
		new CSubmit('encrypt', _('Encrypt')),
		[new CRedirectButton(_('Cancel'), $data['backurl'])]
	));

$guiForm = (new CForm())
	->setAttribute('aria-labeledby', ZBX_STYLE_PAGE_TITLE)
	->addItem($guiView);

$widget->addItem($guiForm);

return $widget;
